/*
	Author:pnminh.it@gmail.com
	De Bai: - xay dung class phanso gom:
		+ tu so , mau so
		- Yeu Cau:
			+ cac ham constructor
			+ ham nhap, xuat, chuyen kieu
			+ da nang hoa toan tu tinh toan: +,-,+=, ++(tien to , hau to)
			+ da nang hoa toan tu so sanh : ==,<,>,
			+ da nang hoa toan tu nhap , xuat: >>, <<
			+ rut gon phan so
*/
#include "iostream.h"
#include "conio.h"
#include "math.h"

class phanso{
	private:
		int tu;
		int mau;
	public:
		phanso(); //contructor khong doi
		phanso(int,int);//contructor co doi so
		phanso(const phanso&p);//ham sao chep contructor
		~phanso();//detructor
		void nhap(); //ham nhap
		void xuat(); //ham xuat
		phanso(int); //chuyen kieu sang kieu so
		phanso operator+(phanso &p);//ham cong phan so
		phanso operator-(int a);//ham tru phan so cho 1 so
		int abss(); //ham tinh can bac hai
		int operator==(phanso &p);//ham so sanh bang
		int operator>(phanso &p);//ham so sanh lon hon
		friend ostream&operator<<(ostream&os,phanso &p);//cout<<
		friend istream&operator>>(istream&is,phanso &p);//cin>>
		phanso operator+=(phanso &p);// ham cong bang
		phanso operator++();//tien to a++;
		phanso operator++(int);//hau to ++a;
		int ucln(int,int); //toi gian
		void rutgon();//toi gian rut gon phan so
};

//begin tru phan so cho 1 so
phanso phanso::operator-(int a){
	tu = tu - a*mau;
	mau = mau;
	return *this;
}
//end tru phan so cho 1 so
//begin rut gon
void phanso::rutgon(){
	int a;
	a = ucln(tu,mau);
	tu = tu/a;
	mau = mau/a;
}
//end rut gon

//begin ucln
int phanso::ucln(int a,int b){
	if(a!=0&&b!=0){
		a=abs(a);
		b=abs(b);
		while(a!=b){
			if(a>b)
				a=a-b;
			else
				b=b-a;
		}
		return a;
	}
	return 0;
}
//end ucln;
//begin tien to ++a;
phanso phanso::operator++(int){
	phanso a;
	a.tu += mau;
	a.mau = mau;
	return a;
}
//end tiento
//begin hau to a++
phanso phanso::operator++(){
	tu = tu + mau;;
	mau = mau;
	return *this;
}
//end hau to a++
//begin cong a = a+b;
phanso phanso::operator+=(phanso &p){
	tu += p.tu;
	mau += p.mau;
	return *this;
}
//end cong a= a+b;
//begin ham can bac 2
int phanso::abss(){
	return sqrt(tu/mau);
}
//end ham can bac 2
//begin ham so sanh lon hon
int phanso::operator>(phanso &p){
	return abss()>p.abss();
}
//end ham so sanh lon hon
//begin so sanh bang
int phanso::operator==(phanso &p){
	return (tu == p.tu && mau == p.mau);
}
//end ham so sanh bang
//contructor khong doi
phanso::phanso(){
	tu = 0;
	mau = 1;
}
//contructor co doi so
phanso::phanso(int t,int m){
	tu = t;
	mau = m;
}
//ham sao chep
phanso::phanso(const phanso&p){
	tu = p.tu;
	mau = p.mau;
}
//ham nhap
void phanso::nhap(){
	cout<<"\nNhap tu: "; cin>>tu;
	do{
		cout<<"\nNhap mau: "; cin>>mau;
	}while(mau==0);
}

//ham cong 2 phan so
phanso phanso::operator+(phanso &p){
	//phanso c;
	tu = tu*p.mau + mau*p.tu;
	mau = mau * p.mau;
	return *this;
}

//da nang hoa toan tu xuat <<
ostream &operator<<(ostream &os,phanso &p){
	if(p.mau < 0){
		p.tu = -p.tu;
		p.mau = p.mau;
	}else if(p.tu == 0){
		os<<p.tu<<endl;
	}else if(p.mau == 1){
		os<<p.tu<<endl;
	}else{
		os<<p.tu<<"/"<<p.mau<<endl;
	}
	return os;
}
//da nang hoa toan tu nhap >>
istream &operator>>(istream &is,phanso &p){
	cout<<"\nNhap tu: "; is>>p.tu;
	cout<<"\nNhap mau: "; is>>p.mau;
	return is;
}
phanso::~phanso(){} //decontructor
//ham xuat
void phanso::xuat(){
	if(mau<0){
		tu = -tu;
		mau = mau;
	}else if(tu==0){
		cout<<"0"<<endl;
	}else if(mau==1){
		cout<<tu<<endl;
	}else{
		cout<<tu<<"/"<<mau<<endl;
	}
}
//ham chuyen doi phan so sang kieu so nguyen
phanso::phanso(int a){
	tu = a;
	mau = 1;
}

void main(){
	clrscr();
	phanso p;
	p.nhap();
	p.rutgon();
	p.xuat();
	phanso e;
	cin>>e;
	e.rutgon();
	cout<<"\nE = "<<e;
	phanso a(24,4);
	a.rutgon();
	cout<<"\nA = "<<a;
	a++;
	cout<<"\na++ = "<<a;
	++e;
	cout<<"\n++e = "<<e;
	cout<<"\na: "; a.xuat();
	phanso b(1,4);
	cout<<"\nb: "; b.xuat();
	phanso c = a+b;
	cout<<"\na + b = ";
	c.rutgon();
	c.xuat();
	getch();
}
