/*
	Author: pnminh.it@gmail.com
	De Bai: - xay dung class sinhvien gom:
		+ masv, hoten , diachi, toan , ly, hoa, dtb;
		- Yeu Cau:
		+ cac ham constructor
		+ viet ham nhap , xuat
		+ da nang hoa toan tu nhap >>, xuat <<
		+ Nhap vao 1 danh sach sinhvien
		+ In danh sach sinh vien vua nhap
		+ Sap xep danh sach theo ten sinh vien
		+ Tim kiem ten sinh vien
		+ Them 1 sinh vien moi
		+ xoa 1 sinh vien khoi danh sach
		+ tim sinh vien co diem trung binh cao nhat
*/
#include "iostream.h"
#include "conio.h"
#include "string.h"

class sinhvien{
	private:
		int masv;
		char hoten[50];
		char diachi[50];
		float toan;
		float ly;
		float hoa;
		float dtb;
	public:
		sinhvien(); // constuctor
		sinhvien(int,char*,char*,float,float,float);//constructor co tham so
		~sinhvien();//destructor
		void nhap();//nhap
		void xuat();//xuat;
		float diemtb();//ham tinh diem trung binh
		friend ostream&operator<<(ostream&os,sinhvien &s);//da nang hoa nhap
		friend istream&operator>>(istream&is,sinhvien &s);//da nang hoa xuat
		float getdtb(){return dtb;}//lay diem trung binh
		//khi nao co tim kiem ten sinh vien thi viet
		char gethoten();//ham lay hoten sinhvien
		int operator==(sinhvien&);
		//xoa thi viet
		int getmasv(){return masv;}

};
int sinhvien::operator==(sinhvien &s){
	return strcmp(hoten,s.hoten)==0;
}
//constructor mac dinh.
sinhvien::sinhvien(){
	masv = 0;
	hoten;
	diachi;
	toan=0;
	ly=0;
	hoa=0;
	dtb=0;
}
//constuctor co' tham so^'
sinhvien::sinhvien(int m,char *h,char *d,float t,float l,float ho){
	masv = m;
	strcpy(hoten,h);
	strcpy(diachi,d);
	toan = t;
	ly = l;
	hoa = ho;
}
//ham deconstructor
sinhvien::~sinhvien(){
}
float sinhvien::diemtb(){
	float tb=0;
	tb = (toan+ly+hoa)/3;
	return tb;
}
void sinhvien::nhap(){
	cout<<"\nNhap Masv: "; cin>>masv;
	cin.ignore(1);
	cout<<"\nNhap Ho Ten: "; cin.getline(hoten,50);
	cout<<"\nNHap Dia Chi: "; cin.getline(diachi,50);
	cout<<"\nDiem Toan: "; cin>>toan;
	cout<<"\nDiem Hoa: "; cin>>hoa;
	cout<<"\nDiem Ly:"; cin>>ly;
}
void sinhvien::xuat(){
	cout<<"\nIN Danh SAch";
	cout<<"\n+ Ma SV: "<<masv;
	cout<<"\n+ Ho Ten: "<<hoten;
	cout<<"\n+ Dia Chi: "<<diachi;
	cout<<"\n+ Diem Toan: "<<toan;
	cout<<"\n+ Diem Hoa: "<<hoa;
	cout<<"\n+ Diem Ly: "<<ly;
	cout<<"\n+ Diem Trung Binh: "<<diemtb();
}
//da nang hoa toan tu nhap cin>>
istream&operator>>(istream&is,sinhvien&s){
	cout<<"\nNHap MaSV: "; is>>s.masv;
	cout<<"\nNhap Ho Ten: "; is>>s.hoten;
	cout<<"\nNhap Dia Chi: "; is>>s.diachi;
	cout<<"\nDiem Toan: "; is>>s.toan;
	cout<<"\nDIem Ly: "; is>>s.ly;
	cout<<"\nDiem Hoa: "; is>>s.hoa;
	return is;
}
//da nang hoa toan tu xuat <<
ostream&operator<<(ostream&os,sinhvien&s){
	os<<"\nMaSV: "<<s.masv;
	os<<"\nHo Ten: "<<s.hoten;
	os<<"\nDia Chi: "<<s.diachi;
	os<<"\nDiem Ly: "<<s.ly;
	os<<"\nDiem Hoa: "<<s.hoa;
	os<<"\nDIem Toan: "<<s.toan;
	os<<"\nDiem TB: "<<s.diemtb();
	return os;
}

char sinhvien::gethoten(){
	return *hoten;
}

void main(){
	clrscr();
	sinhvien s(1,"pham ngoc minh","hai phong",6.0,7.0,8.0),s2,s3;
	cout<<"\nIn Constructor mac dinh:";
	s.xuat();
	int i,j;

	/*Nhap Danh Sach*/
	cout<<"\nNHap so danh sach: "; int n; cin>>n;
	sinhvien *s4 = new sinhvien[n];
	for(i = 0;i<n;i++)
		//s4[i].nhap();
		cin>>s4[i];//cach nhap su dung da nang hoa cin>>

	/*In Danh Sach Vua Nhap*/
	for(i = 0;i<n;i++)
		//s4[i].xuat();
		cout<<s4[i];//cach in su dung da nang hoa cout<<

	/*sap xep theo diem trung binh giam dan*/
	for(i = 0;i<n;i++)
		for(j=i+1;j<n;j++)
		if(s4[i].diemtb() > s4[j].diemtb()){
			sinhvien temp =s4[i];
			s4[i] = s4[j];
			s4[j] = temp;
		}
	/*iN danh sach sau khi sap xep*/
	cout<<"\nDanh Sach Sinh VIen Sau Khi Sap Xep Tang Dan";
	for(i = 0;i<n;i++)
		s4[i].xuat();

	/*Tim Kiem */
	char k[50];
	cin.ignore(1);
	cout<<"\nNhap Ten SinhVien can tim: "; cin.getline(k,50);
	for(i=0;i<n;i++)
		if(s4[i].gethoten()==*k){
			cout<<"\nKet Qua Tim Kiem";
			s4[i].xuat();
		}

	/*Them Sinh Vien*/
	for(i=n;i<n+1;i++)
		s4[i].nhap();

	/*IN Danh Sach Sau Khi Them 1 Sinh Vien */
	cout<<"\nDanh Sach Sau Khi Them 1 Sinh Vien";
	for(i=0;i<n+1;i++)
		s4[i].xuat();

	/*Xoa Sinh Vien*/
	int a;
	cout<<"\nNhap masv can xoa: "; cin>>a;
	for(i=0;i<n;i++)
		if(s4[i].getmasv()!=a){
			s4[i].xuat();
		}

	/*Tim Sinh Vien Co Diem Trung Binh Cao Nhat*/
	for(i=0;i<n-1;i++)
	for(j=i+1;j<n;j++)
		if(s4[i].diemtb() < s4[j].diemtb()){
			sinhvien tg = s4[i];
			s4[i] = s4[j];
			s4[j] = tg;
		}
	cout<<"\nSinh Vien CO diem turng binh cao nhat la: ";
	for(i=0;i<1;i++)
			s4[i].xuat();
	getch();
}
