#include"iostream.h"
#include"conio.h"
#include"string.h" //class bat' buoc. phai? khai bao' lop nay' khi su? dung. chuoi~
#include"assert.h" //class xu ly loi chi su? dung. khi dung ham' assert

class string
{
	private:
		int length;//chieu dai cua chuoi
		char *ptr;//con tro? tro? den vung nho- cap phat' dong.
	public:
		~string();//deconstructor
		string();//constructor
		string(const string&);//ham sao chep
		string(char*); // ham chuyen doi kieu
		string &operator=(string&);//dinh nghia toan tu =
		string &operator+=(string&);//dinh nghia toan tu +=
		int operator!();//dinh nghia phu dinh
		string operator+(string&);//cong 2 chuoi
		int operator==(string&);//dinh nghia toan tu so sanh
		int operator>(string&);// dinh nghia toan tu lon hon
		int operator>=(string&);// dinh nghia toan tu >=
		int operator<(string &); //dinh nghia toan tu <
		int operator<=(string &);
		int operator!=(string &);// dinh nghia toan tu khac nhau
		friend istream &operator>>(istream&is,string &s);//nhap
		friend ostream &operator<<(ostream&os,string &s);//xuat
		char &operator[](int);// tra ve ky tu tham chieu
		string &operator()(int,int);
		int getlength(){return length;};//lay ra do dai cua chuoi
};
//begin: ham cong 2 chuoi
string string::operator+(string &p)
{
	string st;
	st.length=length+p.length;
	st.ptr=new char[st.length+1];
	strcat(ptr,p.ptr);
	strcpy(st.ptr,ptr);
	return st;
}
//begin: tra ve ky tu tham chieu
char &string::operator[](int sub)
{
	assert(sub>=0&&sub<length);
	return ptr[sub];
}
//begin: chi so
string &string::operator()(int index,int sublength)
{
	assert(index>=0&&index<length&&sublength>=0);
	string *subptr=new string;
	assert(subptr!=0);
	if((sublength==0)||(index+sublength>length))
		subptr->length=length-index+1;
	else subptr->length=sublength+1;
	delete subptr->ptr;
	subptr->ptr=new char[subptr->length];
	assert(subptr->ptr!=0);
	strncpy(subptr->ptr,&ptr[index],subptr->length);
	subptr->ptr[subptr->length]='\0';
	return *subptr;
}
//so sanh >=
int string::operator>=(string &p)
{
	return strcmp(ptr,p.ptr)>=0;
}
//being: <
int string::operator<(string &p)
{
	return strcmp(ptr,p.ptr)<0;
}
//so sanh <=
int string::operator<=(string &p)
{
	return strcmp(ptr,p.ptr)<=0;
}

// so sanh != (khac nhau)
int string::operator!=(string &p)
{
	return strcmp(ptr,p.ptr)!=0;
}
// so sanh lon hon >
int string::operator>(string &p)
{
	return strcmp(ptr,p.ptr) > 0;
}
// so sanh bang nhau (==)
int string::operator==(string&p)
{
	return strcmp(ptr,p.ptr)==0;
}
// phep phu dinh !
int string::operator!()
{
	return length==0;
}
// toan tu nhap cin>>
istream &operator>>(istream&is,string &s)
{
	char tmp[100];
	is>>tmp;
	s=tmp;
	return is;
}
//toan tu xuat cout<<
ostream &operator<<(ostream&os,string &s)
{
	os<<s.ptr;
	return os;
}
//toan tu cong bang +=
string &string::operator+=(string&s)
{
	char *tmp=ptr;
	length+=s.length;
	ptr=new char[length+1];
	strcpy(ptr,tmp);
	strcat(ptr,s.ptr);
	delete []tmp;
	return *this;
}

//ham chuyen doi kieu
string::string(char *ptr1)
{
	cout<<"constructor chuyen doi\n";
	length=strlen(ptr1);
	ptr=new char[length+1];
	assert(ptr!=0);
	strcpy(ptr,ptr1);
}

//ham huy doi tuong
string::~string()
{
	cout<<"constructor huy\n";
	delete []ptr;
}

//ham khoi tao khong tham so
string::string()
{
	length=0;
	ptr=NULL;
}

//ham sao chep
string::string(const string&copy)
{
	length=copy.length;
	ptr=new char[length+1];
	assert(ptr!=0);
	strcpy(ptr,copy.ptr);
}
//ham gan = ( a = b)
string &string::operator=(string &s)
{
	if(&s!=this)
	{
		delete []ptr;
		length=s.length;
		ptr=new char[length+1];
		assert(ptr!=0);
		strcpy(ptr,s.ptr);
	}
		return *this;
}

int main()
{
	clrscr();
	string s1("pham ngoc minh "),s2("vo tinh"),s3,s4;
	string s6,s7,s8;
	cout<<"\Nhap S6: ";
	cin>>s6;
	cout<<"\nS6 = "<<s6;
	cout<<"\nNhap S7: ";
	cin>>s7;
	cout<<"\nS7 = "<<s7;
	s8 = s6+s7;
	cout<<"\ns6 + s7 = "<<s8;
	cout<<endl;
	cout<<"s1= "<<s1<<"\n";
	cout<<"s2= "<<s2<<"\n";
	s3=s1;
	cout<<"\ns3= "<<s3;
	s4=s1+s2;
	cout<<"s4= "<<s4<<"\n";
	s4+=s2;
	cout<<"\ns4 += s2: "<<s4<<endl;
	if(s1>s2) cout<<"s1 >= s2";
	else cout<<"s1 <= s2";
	getch();
	return 0;
}