/*
	Author: pnminh.it@gmail.com
	De Bai: - xay dung lop Tam Giac Gom:
		+ canh : a,b,c
		- Yeu Cau:
		+ xay dung constructor
		+ ham nhap, xuat;
		+ da nang hoa toan tu : Cin>>, Cout<<
		+ Viet CHuong Trinh nhap vao tam giac va in ra Dien Tich Tam Giac
		, va cho biet tam giac thuoc loai tam giac gi
		*NOTE: kiem tra dau vao khi nhap tam giac xem co tao thanh tam giac hay ko
*/
#include "iostream.h"
#include "conio.h"
#include "math.h"

class tamgiac{
	private:
		int a;
		int b;
		int c;
	public:
		tamgiac();//constructor mac dinh
		tamgiac(int a1,int b1,int c1);//constructor co tham so
		void nhap();//ham nhap();
		void xuat();//ham xuat();
		friend ostream&operator<<(ostream&os,tamgiac&t);//da nang hoa toan tu xuat cout<<
		friend istream&operator>>(istream&is,tamgiac&t);//da nang hoa toan tu nhap cin>>
		float dientich();
		int kttamgiac();
};

//constructor mac dinh
tamgiac::tamgiac(){
	a = 0;
	b = 0;
	c = 0;
}

//constructor co tham so
tamgiac::tamgiac(int a1,int b1,int c1){
	a = a1;
	b = b1;
	c = c1;
}

//ham nhap
void tamgiac::nhap(){
	do{
		cout<<"\nNhap a: "; cin>>a;
		cout<<"\nNhap b: "; cin>>b;
		cout<<"\nNhap c: "; cin>>c;
	}while(a+b<c||b+c<a||a+c<b);
}

//ham in
void tamgiac::xuat(){
	cout<<"\nDien Tich: "<<dientich();
	cout<<"\nCanh A: "<<a;
	cout<<"\nCanh B: "<<b;
	cout<<"\nCanh C: "<<c;
	int kt = kttamgiac();
	switch(kt){
		case 1: cout<<"\nTam Giac Deu " ; break;
		case 2: cout<<"\nTam Giac vuong can"; break;
		case 3: cout<<"\nTam Giac can"; break;
		case 4: cout<<"\nTam Giac Vuong"; break;
		case 5: cout<<"\nTam Giac Thuong"; break;
	}
}

//da nang hoa toan tu xuat cout<<
ostream&operator<<(ostream&os,tamgiac &t){
	os<<"\nCanh A: "<<t.a;
	os<<"\nCanh B: "<<t.b;
	os<<"\nCanh C: "<<t.c;
	return os;
}

//da nang hoa toan tu nhap cin>>
istream&operator>>(istream&is,tamgiac &t){
	do{
		cout<<"\nNhap a: "; is>>t.a;
		cout<<"\nNhap b: "; is>>t.b;
		cout<<"\nNhap c: "; is>>t.c;
	}while(t.a+t.b<t.c||t.a+t.c<t.b||t.b+t.c<t.a);
	return is;
}

//tinh dien tich
float tamgiac::dientich(){
	float p;
	p = (a+b+c)/2;
	return sqrt(p*(p-a)*(p-b)*(p-c));
}

//kiem tra tam giac
int tamgiac::kttamgiac(){
	if(a==b||b==c||a==c)
		if(a==b&&b==c)
			return 1;//tam giac deu
		else
			if(a*a==b*b+c*c||b*b==a*a+c*c||c*c==a*a+b*b)
				return 2;//tam giac vuong can
			else
				return 3;//tam giac can
	else
		if(a*a == b*b+c*c || b*b == a*a+c*c || c*c == a*a + b*b)
			return 4;//tam giac deu;
		else
			return 5;//tam giac thuong
}
void main(){
	clrscr();
	tamgiac t;
	t.nhap();
	t.xuat();
	getch();
}