/*
	Author:pnminh.it@gmail.com
	De Bai: - Xay Dung lop date gom:
		+ ngay , thang, nam , va mang chua so ngay trong thang
		- Yeu Cau:
		+ xay dung constructor
		+ da nang hoa toan tu:+=, ++ ( tien to , hau to);
		+ da nang hoa toan tu : << ( xuat)
		+ ham kiem tra nam nhuan
		+ ham kiem tra cuoi thang
		+ ham tang ngay len 1 don vi
*/
#include "iostream.h"
#include "conio.h"

class date{
	private:
		int day;//ngay
		int month;//thang
		int year;//nam
		static int days[];//mang chua so ngay trong thang
	public:
		date();//constructor mac dinh
		date(int d,int m,int y);//constructor co tham so
		date operator++();//da nang hoa toan tu ++ tien to;
		date operator++(int);//da nang hoa toan tu ++ hau to;
		int namnhuan(int);//kiem tra nam nhuan
		int cuoithang(int);//kiem tra cuoi thang
		date &operator+=(int);//da nang hoa toan tu +=
		friend ostream&operator<<(ostream&os,date &d);
		void tangngay();//ham tang ngay len 1;
};
//khoi tao gia tri cho so ngay trong thang
int date::days[] = {31,28,31,30,31,30,31,31,30,31,30,31};

//constructor mac dinh
date::date(){
	day = 0;
	month = 0;
	year = 1900;
}

//constructor co tham so
date::date(int d,int m,int y){
	month = (m>=1 && m<=12)?m:1;
	year = (y>=1900 && y<=2100)?y:1900;
	if(month==2 && namnhuan(year)){
		day = (d>=1 && d<=29)?d:1;
	}else{
		day = (d>=1 && d<days[month-1])?d:1;
	}
}

//ham kiem tra nam nhuan
int date::namnhuan(int y){
	if(y % 400 == 0 || (y % 100 != 0 && y % 4 == 0))
		return 1;
	else
		return 0;
}
//ham kiem tra cuoi thang
int date::cuoithang(int d){
	if(month==2 && namnhuan(year)){
		return d == 29;
	}else{
		return d == days[month-1];
	}
}

//ham tang ngay len 1
void date::tangngay(){
	if(cuoithang(day) && month == 12){
		day = 1;
		month = 1;
		++year;
	}else if(cuoithang(day)){
		day = 1;
		++month;
	}else{
		++day;
	}
}
//da nang hoa toan tu ++ tien to
date date::operator++(){
	tangngay();
	return *this;
}

//da nang hoa toan tu ++ hau to
date date::operator++(int){
	date temp = *this;
	tangngay();
	return temp;
}

//da nang hoa toan tu +=
date &date::operator+=(int a){
	for(int i=1;i<=a;i++)
		tangngay();
	return *this;
}
//da nang hoa toan tu xuat COut<<
ostream&operator<<(ostream&os,date &d){
	char *tenthang[12] = {"Thang 1","Thang 2","Thang 3","Thang 4","Thang 5",
				"Thang 6","Thang 7","Thang 8","Thang 9","Thang 10",
				"Thang 11","Thang 12"};
	os<<d.day<<" - "<<tenthang[d.month-1]<<" - "<<d.year;
	return os;
}
void main(){
	clrscr();
	date d1(27,12,1992),d2(99,0,8045),d3(19,3,1969);
	cout<<"\nD1 la: "<<d1;
	cout<<"\nD2 la: "<<d2;
	cout<<"\nD3 = "<<d3;
	cout<<"\nD1 += 7 : "<<(d1+=7)<<endl;
	cout<<"\nD1++ : "<<(d1++)<<endl;
	cout<<"\nD3 = "<<d3<<endl;
	cout<<"\n++D3: "<<(++d3)<<endl;
	getch();
}