/*
	+ Author: pnminh.it@gmail.com
	+ De Bai: xay dung 1 class Ma Tran gom co
		- So Dong , So Cot, mang luu truu gia tri
		+ Yeu Cau Xay Dung:
			- cac constructor
			- ham nhap , xuat
			- da nang hoa toan tu Nhap Cin>> , xuat Cout<<
			- da nang hoa toan tu : +, - , *
			- da nang hoa toan tu: = , == ( cac phep !,!= lam tuong tu)
*/
#include "iostream.h"
#include "conio.h"

class matran{
	private:
		int row;
		int col;
		int a[20][20];
	public:
		matran();//constructor mac dinh
		matran(int,int);//constructor co doi
		void nhap();//ham nhap
		void xuat();//ham xuat
		friend ostream&operator<<(ostream&os,matran &m);//da nang hoa toan tu nhap Cout<<
		friend istream&operator>>(istream&is,matran &m);//da nang hoa toan tu xuat Cin>>
		matran operator+(matran &m);//dinh nghia da nang hoa toan  tu + 2 Ma Tran
		matran operator-(matran &m);//dinh nghia da nang hoa toan tu - 2 Ma Tran
		matran operator*(matran &m);//dinh nghia da nang hoa toan tu  * 2 Ma Tran
		matran operator=(matran &m);//dinh nghia da nang hoa toan tu gan =
		int operator==(matran &m);//dinh nghia da nang hoa toan tu so sanh ==

};

matran::matran(){
	row = 1;
	col = 1;
	a[0][0] = 0;
}
matran::matran(int a,int b){
	row = a;
	col = b;
}

//ham nhap
void matran::nhap(){
	cout<<"\nNhap Dong: "; cin>>row;
	cout<<"\nNhap Cot: "; cin>>col;
	for(int i=1;i<=row;i++)
	for(int j=1;j<=col;j++)
	{
		cout<<"\na["<<i<<"]["<<j<<"]= "; cin>>a[i][j];
	}
}

//ham xuat
void matran::xuat(){
	for(int i=1;i<=row;i++){
		cout<<endl;
		for(int j=1;j<=col;j++)
		cout<<a[i][j]<<" ";
		cout<<endl;
	}
}

//dinh nghia da nang hoa toan tu Nhap cin >>
istream&operator>>(istream&is,matran &m){
	cout<<"\nNhap Dong: "; is>>m.row;
	cout<<"\nNhap Cot: "; is>>m.col;
	for(int i=1;i<=m.row;i++)
	for(int j=1;j<=m.col;j++)
	{
		cout<<"\na["<<i<<"]["<<j<<"] = "; is>>m.a[i][j];
	}
	return is;
}

//dinh nghia da nang hoa toan tu Xuat Cout<<
ostream&operator<<(ostream&os,matran &m){
	for(int i=1;i<=m.row;i++)
	{
		os<<endl;
		for(int j=1;j<=m.col;j++)
			os<<m.a[i][j]<<" ";
			os<<endl;
	}
	return os;
}

//da nang hoa toan tu + 2 Ma Tran
matran matran::operator+(matran &m){
	matran x;
	if(row!=m.row && col != m.col){
		cout<<"\n2 ma tran phai cung cap\n";
	}else{
		x.row = m.row;
		x.col = m.col;
		for(int i=1;i<=x.row;i++)
		for(int j=1;j<=x.col;j++)
			x.a[i][j] = a[i][j] + m.a[i][j];
	}
	return x;

}

//da nang hoa toan tu - 2 Ma Tran
matran matran::operator-(matran &m){
	matran x;
	if(row!=m.row && col != m.col){
		cout<<"\n2 Ma Tran Phai Cung Cap \n";
	}else{
		x.row = m.row;
		x.col = m.row;
		for(int i=1;i<=x.row;i++)
		for(int j=1;j<=x.col;j++)
			x.a[i][j] = a[i][j] - m.a[i][j];
	}
	return x;
}

//da nang hoa toan tu * 2 Ma Tran
matran matran::operator*(matran &m){
	matran x;
	if(row != m.row && col != m.col){
		cout<<"\n2 ma Tran phai cung cap\n";
	}else{
		x.row = m.row;
		x.col = m.col;
		for(int i=1;i<=x.row;i++)
		for(int j=1;j<=x.col;j++)
		{
			x.a[i][j] = 0,0;
			for(int k=1;k<=x.col;k++)
			x.a[i][j] += a[i][k]*m.a[k][j];
		}
	}
	return x;
}

//dinh nghia da nang hoa toan tu gan =
matran matran::operator=(matran &m){
	row = m.row;
	col = m.col;
	for(int i=1;i<=row;i++)
	for(int j=1;j<=col;j++)
		a[i][j] = m.a[i][j];
	return *this;
}

//dinh nghia da nang hoa toan tu so sanh ==
int matran::operator==(matran &m){
	if(row == m.row && col == m.col){
		for(int i=1;i<=row;i++)
		for(int j=1;j<=col;j++)
			if(a[i][j] != m.a[i][j])
				return 0;
			else
				return 1;
	}else
	     return 0;
	return 1;
}
//ham main
void main(){
	clrscr();
	matran m;
	m.nhap();
	m.xuat();
	matran n;
	cin>>n;
	cout<<n;
	matran e = m+n;
	cout<<"\nM + N = ";
	e.xuat();
	matran f = m-n;
	cout<<"\nM - N = "<<f;
	matran g = m*n;
	cout<<"\nM * N = "<<g;
	matran h = g;//kiem tra ham gan 2 ma tran
	cout<<h;
	if(h==f)//ham so sanh 2 ma tran
		cout<<"\nH == F";
	else
		cout<<"\nH != F";
	getch();
}