/*
	Author:pnminh.it@gmail.com
	De Bai: - xay dung class sophuc gom:
		+ phan thuc, phan ao;
		- Yeu Cau:
			+ xay dung cac ham constructor
			+ ham nhap, xuat
			+ da nang hoa toan tu : +,*,+=,-=;
			+ da nang hoa toan tu so sanh:<,>,==,!,=,++,
			+ da nang hoa toan tu nhap, xuat : >>, <<
*/
#include"iostream.h"
#include"conio.h"
#include"math.h"

class sophuc
{
	private:
		float th;
		float ao;
		float abs();
	public:
		sophuc();
		sophuc(float,float);
		~sophuc();
		sophuc(const sophuc &);// ham sao chep
		sophuc(float);//chuyen doi
		//toan tu tinh toan
		sophuc operator+(sophuc);//da nang hoa toan tu +
		sophuc operator*(sophuc);//da nang hoa toan tu *
		sophuc operator+=(sophuc);//da nang hoa toan tu +=
		sophuc operator-=(sophuc);//da nang hoa toan tu -=
		//toan tu so sanh
		int operator==(sophuc);
		int operator!=(sophuc);
		int operator<(sophuc);
		int operator>(sophuc);
		sophuc operator++();//hau to
		sophuc operator=(sophuc);//gan
		sophuc operator++(int);//tien to
		friend ostream&operator<<(ostream&os,sophuc&);
		friend istream&operator>>(istream&is,sophuc&);
		void in();
};

sophuc sophuc::operator++(int)
{
	sophuc tmp;
	++th;
	++ao;
	return tmp;
}

sophuc::sophuc(float a)
{
	th=a;
	ao=0;
}

sophuc::sophuc(const sophuc&a)
{
	th=a.th;
	ao=a.ao;
}


sophuc sophuc::operator=(sophuc a)
{
	th=a.th;
	ao=a.ao;
	return *this;
}

float sophuc::abs()
{
	return sqrt(th*th+ao*ao);
}

sophuc sophuc::operator++()
{
	th++;
	ao++;
	return *this;
}

int sophuc::operator>(sophuc a)
{
	return abs()>a.abs();
}

int sophuc::operator<(sophuc a)
{
	return abs()<a.abs();
}

sophuc sophuc::operator-=(sophuc a)
{
	th-=a.th;
	ao-=a.ao;
	return *this;
}

sophuc sophuc::operator+=(sophuc a)
{
	th+=a.th;
	ao+=a.ao;
	return *this;
}

int sophuc::operator==(sophuc a)
{
	return ((th==a.th)&&(ao==a.ao));
}

int sophuc::operator!=(sophuc a)
{
	return ((th!=th)||(ao!=a.ao));
}


sophuc::sophuc()
{
	th=0;
	ao=0;
}
sophuc::sophuc(float th1,float ao1)
{
	th=th1;
	ao=ao1;
}
sophuc::~sophuc()
{}

ostream&operator<<(ostream&os,sophuc&s)
{
	os<<"\nthuc la: "<<s.th;
	os<<"\nAo la: "<<s.ao;
	return os;
}

istream&operator>>(istream&is,sophuc&s)
{
	cout<<"nhap thuc: "; is>>s.th;
	cout<<"nhap ao: "; is>>s.ao;
	return is;
}

sophuc sophuc::operator+(sophuc a)
{
	sophuc c;
	c.th=th+a.th;
	c.ao=ao+a.ao;
	return c;
}

sophuc sophuc::operator*(sophuc a)
{
	sophuc c;
	c.th=th*a.th;
	c.ao=ao*a.ao;
	return c;
}

void sophuc::in()
{
	cout<<th<<"+"<<ao<<"i"<<"\n";
}

int main()
{
	clrscr();
	sophuc a(2,3);
	cout<<"a= ";
	a.in();
	sophuc b(5,4);
	cout<<"b= ";
	b.in();
	sophuc c=a+b;
	c.in();
	if(a==b) cout<<"a==b";
	else cout<<"a!=b";
	++a;
	a.in();
	b++;
	b.in();
	getch();
	return 0;
}