/*
	Author: pnminh.it@gmail.com
	De Bai:
		- Xay Dung Lop Time gom co:
		+ gio(hour),phut(mine),giay(second);
		- Yeu Cau:
		+ xay dung cac constructor
		+ ham nhap, xuat
		+ da nang hoa toan tu: ++ len 1 time
		+ da nang hoa toan tu Nhap Xuat : cin>>, cout<<
		+ da nang hoa toan tu - 1 time cho 1 so
		+ viet chuong trinh: khoi tao 1 gia tri thoi gian va tang len 5 Giay
		dong thoi hien thi thoi gian sau moi lan tang
		*NOTE: chu y khi xuat ra gio phai co dang 24 tieng va 12 tieng AM,PM

*/

#include "iostream.h"
#include "conio.h"

class time{
	private:
		int hour;
		int mine;
		int second;
	public:
		time();//constructor mac dinh
		time(int gio,int phut,int giay);//khoi tao constructor co tham so
		time(int);//chuyen 1 so ve dang time
		time operator++(int); //da nang hoa toan tu ++ len 1 don vi thoi gian
		void in12();//ham in gio duoi dang 12 tieng AM : PM
		void in24();//ham in gio duoi dang 24 tieng
		void nhap();//ham nhap
		friend ostream&operator<<(ostream&os,time &t);//da nang hoa toan tu Xuat Cout<<
		friend istream&operator>>(istream&is,time &t);//da nang hoa toan tu Nhap CIN>>
		void tanggiay(); //ham tang giay len 1
		void tangphut(); //ham tang phut len 1
		void tanggio();  //ham tang gio len 1
};

//ham nhap thoi gian
void time::nhap(){
	cout<<"\nNhap gio: "; cin>>hour;
	cout<<"\nNhap Phut : "; cin>>mine;
	cout<<"\nNhap Giay: ";cin>>second;
}

//constructor khong tham so
time::time(){
	hour = 0;
	mine = 0;
	second = 0;
}

//constructor co tham so
time::time(int gio,int phut,int giay){
	hour = gio;
	mine = phut;
	second = giay;
}

//ham chuyen doi 1 so nguyen ve dang thoi gian
time::time(int a){
	hour = 0;
	mine = 0;
	second = a;
}

// ham da nang hoa toan tu ++ 1 time len 1 don vi
time time::operator++(int){
	second++;
	this->mine += this->second/60;
	this->second = this->second%60;
	this->hour += this->mine/60;
	this->mine = this->mine % 60;
	if(this->hour==24) this->hour = 0;
	return *this;
}

//ham in thoi gian duoi dang 24 tieng
void time::in24(){
	cout<<"\nGio: "<<(hour<10?"0":"")<<hour<<" : "<<(mine<10?"0":"")<<mine<<" : "<<(second<10?"0":"")<<second<<endl;
}

//in thoi gian duoi dang 12 tieng
void time::in12(){
	if(0<=hour && hour<=11){
		cout<<"\nGio: "<<hour<<" : "<<"Phut: "<<mine<<" : "<<"Giay: "<<second<<" AM"<<endl;
	}else if(hour==12){
		cout<<"\nGio: "<<hour<<" : "<<"Phut: "<<mine<<" : "<<"Giay: "<<second<<" PM"<<endl;
	}else{
		cout<<"\nGio: "<<hour-12<<" : "<<"Phut: "<<mine<<" : "<<"Giay: "<<second<<" PM"<<endl;
	}
}

//da nang hoa toan tu xuat Cout<<
ostream&operator<<(ostream&os,time &t){
	if(t.hour >=0 && t.hour <=11){
		os<<"\nGio: "<<t.hour<<" : Phut"<<t.mine<<": Giay"<<t.second<<" AM "<<endl;
	}else if(t.hour == 12){
		os<<"\nGio: "<<t.hour<<" : "<<"Phut: "<<t.mine<<" : "<<"Giay: "<<t.second<<" PM "<<endl;
	}else{
		os<<"\nGio: "<<t.hour-12<<" : "<<"Phut: "<<t.mine<<" : "<<"Giay: "<<t.second<<" PM "<<endl;
	}
	return os;
}

//da nang hoa toan tu nhap Cin >>
istream&operator>>(istream&is,time &t){
	cout<<"\nNhap Gio: "; is>>t.hour;
	cout<<"\nNhap Phut: "; is>>t.mine;
	cout<<"\nNhap Giay: "; is>>t.second;
	return is;
}

//tang gio
void time::tanggio(){
	hour++;
	if(hour==12) hour = 0;
}

//tang phut
void time::tangphut(){
	mine++;
	if(mine==60){
		mine = 0;
		tanggio();
	}
}

//tang giay
void time::tanggiay(){
	second++;
	if(second==60){
		second = 0;
		tangphut();
	}
}

void main(){
	clrscr();
	time t1(23,59,58);
	time t;
	t.nhap();
	cout<<"\nT = ";
	t.in12();
	t.in24();
	cout<<"\nT1 = "<<t1;
	cout<<"\nSau Khi Tang T1 len 5 Giay:\n";
	for(int i=0;i<=5;i++){
		t1.tanggiay();
		t1.in12();
	}
	time t2(23,59,59);
	cout<<"\nT2 = "<<t2;
	t2++;
	cout<<"\nT2 ++ "<<t2;

	getch();

}